/*
Author     :  AA-Team - http://themeforest.net/user/AA-Team
*/

// Initialization and events code for the app
WooZonePNF_admin = (function ($) {
    "use strict";

    // public
    var debug_level = 0,
        maincontainer = null,
        $action_status = null,
        notices_main = null,
        loading = null,
        notices_opt = {},
        file_frame, image_data, mainimage;;
    
	// init function, autoload
	(function init() {
		// load the triggers
		$(document).ready(function(){
			maincontainer = $(".WooZonePNF_iw");
			$action_status = maincontainer.find(".WooZonePNF-action-status.WooZonePNF-message");

            notices_main = $("#WooZonePNF-admin-mainnotices");

			triggers();

			loading = $(".WooZonePNF_iw-loader");

			loading.hide();

			fix_content_width();

			box_style();
			typo();
		});

		$(window).resize(function(){
			fix_content_width();
		});
	})();
	
	function get_box_settings( str )
	{
		var regex = /\[(.*?)\]/g;

		var res = str.match(regex);

		return {
			'box' : res[1].replace("]", '').replace("[", ''),
			'option' : res[2].replace("]", '').replace("[", ''),
		};
	}

	function typo()
	{
		function add_font( font ) {
			var google_font_url = "http://fonts.googleapis.com/css?family=" + font;
			
			if( $("#WooZonePNF-fonts-" + font ).size() == 0 ){ 
				//console.log( 'write font'  );
				$("head").append("<link href='" + ( google_font_url ) + "' id='WooZonePNF-fonts-" + ( font ) +  "' rel='stylesheet' type='text/css'>");
			}
		};

		maincontainer.find(".WooZonePNF-typo-wrapper .WooZonePNF-typo-row").each(function(){
			var that = $(this),
				preview = that.find(".WooZonePNF-typo-font-preview");

			function refresh()
			{
				var family = that.find(".WooZonePNF-typo-font-family select").val();
				var size = that.find(".WooZonePNF-typo-font-size select").val();
				var color = that.find(".WooZonePNF-typo-font-color input").val();
				var background = that.find(".WooZonePNF-typo-background-color input").val();

				if( family != "system" ){
					add_font( family );
				}

				preview.css({
					'font-family': family,
					'font-size': size + "px",
					'color': color
				});

				if( color == '#ffffff' ){
					preview.css('background-color', "#a997b2");
				}else{
					preview.css('background-color', "#fff");
				}

				if( typeof(background) != "undefined" ){
					preview.css('background-color', background );
				}
			}

			refresh();

			that.find('.WooZonePNF-wp-color-picker-typo').wpColorPicker({
				change: function(event, ui){
					refresh();
				}
			});

			that.on('change', 'select', refresh );
		});
	}

	function box_style()
	{
		maincontainer.find(".WooZonePNF-box-style").each(function(){
			var that = $(this),
				preview = that.find(".WooZonePNF-box-preview"),
				preview_span = preview.find("span").eq(0),
				export_text = that.find(".WooZonePNF-box-settings-export-style");

			var radius_css 		= '';
			var topLeft 		= 10;
			var topRight 		= 10;
			var bottomLeft  	= 10;
			var bottomRight   	= 10;
			var borderWidth    	= 0;
			var borderStyle    	= 'none';
			var borderColor    	= '#5f3a71';
			var backgroundColor = '#5f3a71';

			var horizontal  	= 40;
			var vertical  		= 40;
			var blur  			= 40;
			var spread  		= 40;
			var opacity  		= 0.7;
			var shadowColor  	= '#23282d';
			var type  			= 'inset';

			function hexToRgbA(hex)
			{
			    var c;
			    if(/^#([A-Fa-f0-9]{3}){1,2}$/.test(hex)){
			        c= hex.substring(1).split('');
			        if(c.length== 3){
			            c= [c[0], c[0], c[1], c[1], c[2], c[2]];
			        }
			        c= '0x'+c.join('');
			        return 'rgba('+[(c>>16)&255, (c>>8)&255, c&255].join(',')+', ' + ( ( opacity / 100 ) ) + ')';
			    }
			    //throw new Error('Bad Hex');
			}

			function _box_shadow_code() 
			{

			    var res = '';
			    if (type == 'inset' ){
			        res += 'inset ';
			    }

			    res += horizontal + 'px ';
			    res += vertical + 'px ';
			    res += blur + 'px ';
			    res += spread + 'px ';
			    res += hexToRgbA(shadowColor);
			    return res;
			}

			function refresh() 
			{
				that.find(".WooZonePNF-box-content[data-rel='border-radius'] label, .WooZonePNF-box-content[data-rel='box-shadow'] label").each(function(){
					var _that = $(this),
						option = _that.find("input");

					if( option.size() == 0 ){
						option = _that.find("select");
					}
					if( option.size() > 0 ){
						var _settings = get_box_settings( option.attr('name') );	

						if( _settings.box == 'radius' ){
							if( _settings.option != 'all' ){

								if( _settings.option == 'top-left' ){
									topLeft = option.val();
								}
								if( _settings.option == 'top-right' ){
									topRight = option.val();
								}
								if( _settings.option == 'bottom-left' ){
									bottomLeft  = option.val();
								}
								if( _settings.option == 'bottom-right' ){
									bottomRight = option.val();
								}
								if( _settings.option == 'border-width' ){
									borderWidth  = option.val();
								}
								if( _settings.option == 'border-style' ){
									borderStyle = option.val();
								}
								if( _settings.option == 'border-color' ){
									borderColor = option.val();
								}
								if( _settings.option == 'background-color' ){
									backgroundColor = option.eq(0).val();
								}
							}
						}

						if( _settings.box == 'box-shadow' ){
							if( _settings.option == 'horizontal' ){
								horizontal = option.val();
							}
							if( _settings.option == 'vertical' ){
								vertical = option.val();
							}
							if( _settings.option == 'blur' ){
								blur = option.val();
							}
							if( _settings.option == 'spread' ){
								spread = option.val();
							}
							if( _settings.option == 'shadow' ){
								shadowColor = option.val();
							}
							if( _settings.option == 'type' ){
								type = option.val();
							}
							if( _settings.option == 'opacity' ){
								opacity = option.val();
							}
						}
					}
				});

			    var css_code = '', css_code2 = '';
			    css_code += topLeft + 'px ' + topRight + 'px ' + bottomRight + 'px ';
			    css_code += bottomLeft + 'px ';
			    
			    css_code2 += borderWidth + 'px ' + borderStyle + ' ' + borderColor;

			   	preview_span.css( 'border-radius', css_code );
			   	preview_span.css( '-moz-border-radius', css_code );
			   	preview_span.css( '-webkit-border-radius', css_code );
			   	preview_span.css( 'border', css_code2 );

			   	preview_span.css('background-color', backgroundColor);

			   	//console.log( backgroundColor  ); 

			   	var code_box_shadow = _box_shadow_code();
				preview_span.css({
					'-webkit-box-shadow': code_box_shadow,
					'-moz-box-shadow': code_box_shadow,
					'box-shadow': code_box_shadow
				});

				var export_str = [];
				export_str.push( "##box-selector## {" );
				export_str.push( 	"border-radius: " + css_code + ";"  );
				export_str.push( 	"-moz-border-radius: " + css_code + ";"  );
				export_str.push( 	"-webkit-border-radius: " + css_code + ";"  );
				export_str.push( 	"border: " + css_code2 + ";"  );
				export_str.push( 	"background-color: " + backgroundColor + ";"  );
				export_str.push( 	"/* shadow */"  );
				export_str.push( 	"-webkit-box-shadow: " + code_box_shadow + ";"  );
				export_str.push( 	"-moz-box-shadow: " + code_box_shadow + ";"  );
				export_str.push( 	"box-shadow: " + code_box_shadow + ";"  );
				export_str.push( "}" );

				export_text.val( export_str.join("\n") );
			}

			refresh();

			that.find(".WooZonePNF-box-settings-slider").each(function(){

				var slider = $(this),
					parent = slider.parents('label').eq(0),
					input = parent.find("input");
				
				$(this).slider({
					orientation: "horizontal",
					range: "min",
					min: slider.data("min"),
					max: slider.data("max"),
					value: slider.data("def"),
					step: slider.data("step") || 1,
					slide: function( event, ui ) {
				      	var _settings = get_box_settings( input.attr('name') );

				      	if( _settings.box == 'radius' ){
				      		if( _settings.option == 'all' ){
				      			// get next 4 labels and make all same value
				      			var next_elm = parent.next();
				      			for( var i = 0; i < 4; i++ ){
				      				next_elm.find("input").val( ui.value );

				      				next_elm.find(".WooZonePNF-box-settings-slider").slider( "value", ui.value );
				      				next_elm = next_elm.next();
				      			}
				      		}

				      	}
				      	input.val( ui.value );

				      	refresh();
				    }
			    });
			});


		    that.on('change', 'input,select', function(){
		    	var __that 	= $(this),
		    		val 	= __that.val();

		    	refresh();
		    });

		    that.on('keyup', 'input,select', function(){
		    	var __that 	= $(this),
		    		val 	= __that.val();

		    	refresh();
		    });

		    that.find('.WooZonePNF-wp-color-picker-box').wpColorPicker({
				change: function(event, ui){
					refresh();
				}
			});

			that.on('click', 'a.WooZonePNF-box-settings-title', function(e){
				e.preventDefault();

				var that_click = $(this);

				that.find("a.WooZonePNF-box-settings-title.on").removeClass("on");

				that_click.addClass('on');
				that.find(".WooZonePNF-box-content").hide();
				that.find('.WooZonePNF-box-content[data-rel="' + ( that_click.data('rel')  ) + '"]').show();
			});
		});
	}

	function update( data )
	{
		maincontainer.find(".WooZonePNF_iw-loader").show();
		
		maincontainer.find(".WooZonePNF_iw-loader").find('span').html('');
		$.ajax({
			url: ajaxurl,
			data: $.extend(
				{
					_ajax_custom_list_nonce: $('#_ajax_custom_list_nonce').val(),
					action: $("#ajaxid").val()
				},
				data
			),
			// Handle the successful result
			success: function( response ) {

				// WP_List_Table::ajax_response() returns json
				var response = $.parseJSON( response );

				// add the requested rows
				if ( response.rows.length )
					maincontainer.find('#the-list').html( response.rows );
					
				// update column headers for sorting
				if ( response.column_headers.length )
					maincontainer.find('thead tr, tfoot tr').html( response.column_headers );
					
				// update pagination for navigation
				if ( response.pagination.bottom.length )
					maincontainer.find('.tablenav.top .tablenav-pages').html( $(response.pagination.top).html() );
					
				if ( response.pagination.top.length )
					maincontainer.find('.tablenav.bottom .tablenav-pages').html( $(response.pagination.bottom).html() );

				// init back our event handlers
				triggers();
				
				// hide the loader
				maincontainer.find(".WooZonePNF_iw-loader").fadeOut(250);
			}
		});
	}
	
	function __query( query, variable )
	{
		var vars = query.split("&");
		for ( var i = 0; i <vars.length; i++ ) {
			var pair = vars[ i ].split("=");
			if ( pair[0] == variable )
				return pair[1];
		}
		return false;
	}
	
	function fix_content_width()
	{
		maincontainer.css({
			'height': ( $("#wpwrap").height() - 90 )
		});
	}

	function multiselect_left2right( autselect ) {
		var $allListBtn = $('.multisel_l2r_btn');
		var autselect = autselect || false;
 
		if ( $allListBtn.length > 0 ) {
			$allListBtn.each(function(i, el) {
 
				var $this = $(el), $multisel_available = $this.prevAll('.WooZonePNF-multiselect-available').find('select.multisel_l2r_available'), $multisel_selected = $this.prevAll('.WooZonePNF-multiselect-selected').find('select.multisel_l2r_selected');
 
				if ( autselect ) {
					$multisel_selected.find('option').each(function() {
						$(this).prop('selected', true);
					});
					$multisel_available.find('option').each(function() {
						$(this).prop('selected', false);
					});
				} else {

				$this.on('click', '.moveright', function(e) {
					e.preventDefault();
					$multisel_available.find('option:selected').appendTo($multisel_selected);
				});
				$this.on('click', '.moverightall', function(e) {
					e.preventDefault();
					$multisel_available.find('option').appendTo($multisel_selected);
				});
				$this.on('click', '.moveleft', function(e) {
					e.preventDefault();
					$multisel_selected.find('option:selected').appendTo($multisel_available);
				});
				$this.on('click', '.moveleftall', function(e) {
					e.preventDefault();
					$multisel_selected.find('option').appendTo($multisel_available);
				});
				
				}
			});
		}
	}

    /* BEGIN aa-framework */
    function make_tabs()
    {
    	function show_tab_elements( link, form, that )
    	{
    		var link_name = link.find("a").attr("href").replace("#", "");

    		// hide all elements
    		form.find( ".WooZonePNF-form-row:not(." + ( link_name ) + "), .WooZonePNF-message:not(." + ( link_name ) + ")" ).hide();

    		var cc = 0;
    		form.find( ".WooZonePNF-form-row." + link_name + ", .WooZonePNF-message." + link_name ).each(function(){
    			var that = $(this);
    			
    			that.show();

    			if( cc % 2 == 0 ){
    				that.addClass("WooZonePNF-even");
    			}

    			if( cc % 1 == 0 ){
    				that.addClass("WooZonePNF-odd");
    			}

    			cc++;
    		});

    		that.find(".on").removeClass("on");
    		link.addClass("on");
    	}

		maincontainer.find(".WooZonePNF-settings-tabs").each(function(){
			var that = $(this),
				form = that.parents("form").eq(0),
				link = that.find("li").eq(0);

			show_tab_elements( link, form, that );

			that.on('click', 'li a', function(e){
				e.preventDefault();
				var link = $(this).parent("li");
				
				show_tab_elements( link, form, that );
			});
       });
    }
    
    
    function saveOptions($btn)
    {
        var theForm         = $btn.parents('form').eq(0),
            value           = $btn.val(),
            statusBoxHtml   = theForm.find('div#WooZonePNF-status-box');

        // replace the save button value with loading message
        $btn.val('saving setings ...').removeClass('green').addClass('gray');
        
        theForm.submit();
        
        // replace the save button value with default message
        $btn.val( value ).removeClass('gray').addClass('green');
    }
	
	function same_height( $elms )
	{
		$elms.each(function(){
			var row 		= $(this),
				maxHeight 	= 0,
				childs 		= row.find(">div .WooZonePNF_iw-dashboard-in-box-content");

			childs.each(function(){
				var that = $(this),
					height = that.height();

				if( maxHeight <= height ){
					maxHeight = height;
				}
			});
			if( maxHeight > 0 ) childs.height( maxHeight );
		});
	}

	function font_preview() 
	{
		function change_font( preview_elm ) {
			var that = preview_elm,
				pair_element = that.parents('.WooZonePNF-form-item:first').find('select'),
				pair_value = pair_element.val(),
				google_font_url = "http://fonts.googleapis.com/css?family=" + pair_value;
			
			// step 1, load into DOM the spreadsheet
			$("head").append("<link href='" + ( google_font_url ) + "' rel='stylesheet' type='text/css'>");
			
			// step 2, print the font name into preview with inline font-family
			that.html( "<span style='font-family: " + ( pair_value ) + "'>Grumpy wizards make toxic brew for the evil Queen and Jack.</span>" );
		};
		
		$(".WooZonePNF-font-preview").each(function(){
			var that = $(this),
				pair_element = that.parents('.WooZonePNF-form-item:first').find('select');

			change_font( that );

			pair_element.change(function(e) {
				var preview = $(this).parents('.WooZonePNF-form-item:first').find('.WooZonePNF-font-preview');
				change_font( preview );
			});
		});
	};

	function register_plugin( that )
	{
		var form = that.parents('form').eq(0);

		loading.show();
		var data = {
            'action'	: 'WooZonePNF_register',
			'params'	: form.serialize()
       	};
       	
		$.post(ajaxurl, data, function (response) {
			
			if( response.status == 'valid' ){
				location.reload();
			}

			loading.hide();
			
        }, 'json');
	}

	function campaigns()
	{

		maincontainer.on('click', "#WooZonePNF_iw-add-new-campaign", function(e){
			e.preventDefault();

			var value = $(this).parents('div').eq(0).find('input').val();

			if( value == '' ){
				alert("Please use a valid name for your campaign!");
				return;
			}

			var data = {
	            'action'	: 'WooZonePNF_action',
	            'sub_action': 'add_campaign',
				'params'	: {
					'name': value
				}
	       	};

	       	$(this).parents('div.WooZonePNF-no-campaigns-wrapper').eq(0).hide();
	       	$.post(ajaxurl, data, function (response) {
				if( response.status == 'valid' ){
					window.location = response.redirect_url;
					return true;
				}else{
					alert( response.msg );
						$(this).parents('div.WooZonePNF-no-campaigns-wrapper').eq(0).show();
				}
	        }, 'json');
		});

		maincontainer.on('click', "#WooZonePNF_iw-add-new-campaign-block", function(e){
			e.preventDefault();

			loading.show();

			var that = $(this);
			maincontainer.find(".WooZonePNF-no-campaigns-wrapper").show();
		});

		maincontainer.on('click', "#WooZonePNF-delete-campaign-btn", function(e){
			e.preventDefault();

			var id = $(this).data('id');

			if (confirm("Are you sure you want to delete all Campaign data (template setup and products)") === false ) {
				return false;
			}

			loading.show();

			var data = {
	            'action'	: 'WooZonePNF_action',
	            'sub_action': 'remove_campaign',
				'params'	: {
					'id': id
				}
	       	};
	       	
			$.post(ajaxurl, data, function (response) {
				
				if( response.status == 'valid' ){
					location.reload();
				}
				
	        }, 'json');
		});


		/*maincontainer.find('.WooZonePNF-campaigns-selector').each(function(){
			var that = $(this);

			that.on('click', ".WooZonePNF-campaigns-btn-add-new", function(e){
				e.preventDefault();

				that.find(".WooZonePNF-campaigns-add-new-box").toggle();
			});

			that.on('click', ".WooZonePNF-create-campaign-btn", function(e){
				e.preventDefault();

				loading.show();

				var data = {
		            'action'	: 'WooZonePNF_action',
		            'sub_action': 'add_campaign',
					'params'	: {
						'name': that.find("[name='WooZonePNF-campaigns-name']").val()
					}
		       	};
		       	
				$.post(ajaxurl, data, function (response) {
					
					if( response.status == 'valid' ){
						location.reload();
					}
					
		        }, 'json');
			});
			
			that.on('click', ".WooZonePNF-campaign-delete", function(e){
				e.preventDefault();

				var box = $(this).parents("div").eq(0),
					id = box.data('id');

				if( id == 'default' ){

					alert("The default campaign is mandatory for your install!");
					return false;
				}

				if (confirm("Are you sure you want to delete all Campaign data (template setup and products)") === false ) {
					return false;
				}

				loading.show();

				var data = {
		            'action'	: 'WooZonePNF_action',
		            'sub_action': 'remove_campaign',
					'params'	: {
						'id': id
					}
		       	};
		       	
				$.post(ajaxurl, data, function (response) {
					
					if( response.status == 'valid' ){
						location.reload();
					}
					
		        }, 'json');
			});
		});*/

	}

	function download_URL(url) 
	{
	    var hiddenIFrameID = 'hiddenDownloader',
	    iframe = document.getElementById(hiddenIFrameID);
	    if (iframe === null) {
	        iframe = document.createElement('iframe');
	        iframe.id = hiddenIFrameID;
	        iframe.style.display = 'none';
	        document.body.appendChild(iframe);
	    }
	    iframe.src = url;
	}

	function generatePass(plength)
	{
	    var keylistalpha="abcdefghijklmnopqrstuvwxyz";
	    var keylistint="123456789";
	    var keylistspec="!@#_";
	    var temp='';
	    var len = plength/2;
	    var len = len - 1;
	    var lenspec = plength-len-len;
	    var i = 0;
	    for (i=0;i<len;i++)
	        temp+=keylistalpha.charAt(Math.floor(Math.random()*keylistalpha.length));

	    for (i=0;i<lenspec;i++)
	        temp+=keylistspec.charAt(Math.floor(Math.random()*keylistspec.length));

	    for (i=0;i<len;i++)
	        temp+=keylistint.charAt(Math.floor(Math.random()*keylistint.length));

	        temp=temp.split('').sort(function(){return 0.5-Math.random()}).join('');

	    return temp;
	}

	function new_password( that )
	{
		that.prev('input').val( generatePass( 10 ) );
	}

	function on_off_swich()
	{
		maincontainer.find(".WooZonePNF_iw_switch").each(function(){
			var that 		= $(this),
				switchState = false,
				input = that.find("input"),
				default_val = input.val();


			if( default_val == 'off' ){
				switchState = true;
				that.find('.WooZonePNF_iw_circle').addClass('WooZonePNF_iw_move-circle-right').addClass('WooZonePNF_iw_move-no-animation');
				setTimeout( function(){
					that.find('.WooZonePNF_iw_circle').removeClass('WooZonePNF_iw_move-no-animation');
				}, 500);

				that.find(".WooZonePNF_iw_off").css("opacity", 1);
			    that.find(".WooZonePNF_iw_on").css("opacity", 0);
			}

			that.click( function() {
				var that2 =  $(this);
			    if (switchState) {
			        that2.find('.WooZonePNF_iw_circle').removeClass("WooZonePNF_iw_move-circle-right").addClass("WooZonePNF_iw_move-circle-left");
			        that2.find(".WooZonePNF_iw_off").css("opacity", 0);
			        that2.find(".WooZonePNF_iw_on").css("opacity", 1);
			        switchState = false;

			        that2.find("input").val( 'on' );
			        that2.find("input").trigger("change");

			    } 
			    else if (!switchState) {
			        that2.find('.WooZonePNF_iw_circle').removeClass("WooZonePNF_iw_move-circle-left").addClass("WooZonePNF_iw_move-circle-right");
			        that2.find(".WooZonePNF_iw_off").css("opacity", 1);
			        that2.find(".WooZonePNF_iw_on").css("opacity", 0);
			        switchState = true;

			        that2.find("input").val( 'off' );
			        that2.find("input").trigger("change");
			    }
			});

			that.on("change", 'input', function(){
				var that3 = $(this),
					val = that3.val(),
					next_div = that.next('div');

				if( val == 'on' ){
					next_div.show();
				}else{
					next_div.hide();
				}
			});

			that.find("input").trigger("change");
		});
	}

	function country_dropdown()
	{
		maincontainer.find(".WooZonePNF_country_dropdown").each(function(){
			var that = $(this),
				val = that.find("input").val(),
				current = that.find("li[data-country='" + ( val ) + "']"),
				print_elm = that.find(".WooZonePNF_country_dropdown-current");

			function change_print_val( current, val )
			{
				print_elm.find("img").attr( 'src', current.find('img').attr('src') );
				print_elm.find("span").text( current.find('span').text() );

				that.find("input").val( val );

				that.find(".is_select").removeClass('is_select');
				current.addClass('is_select');
				that.find("ul").hide();
			}

			that.on('click', 'li', function(){
				current = $(this);
				change_print_val( current, current.data('country') );
			});

			print_elm.click(function(){
				that.find("ul").toggle();
			});

			// default
			change_print_val( current, val );
		})
	}

	function triggers()
	{
		country_dropdown();
		on_off_swich();
		same_height( maincontainer.find(".WooZonePNF_iw-section-dashboard-row") );
        make_tabs();
        campaigns();
        multiselect_left2right();

 		maincontainer.on('click', '.WooZonePNF-btn-new-password', function(e){
			e.preventDefault();
			
			new_password( $(this) );
		});
		
		$('body').on('click', ".WooZonePNF-tmdb-auth-box-header a:not(.on)", function(e){
			e.preventDefault();
			var that = $(this),
				rel = $(that.attr('href')),
				preload = $(".WooZonePNF-tmdb-auth-containers .WooZonePNF_iw-loader");
				
			preload.show();
			
			$(".WooZonePNF-tmdb-auth-box-header a.on").removeClass("on");
			$(".WooZonePNF-tmdb-tab-auth").hide();
			rel.show();
			
			if( that.attr('href') == '#WooZonePNF-tmdb-auth-tab-user' ){
				$.ajax({
					url: ajaxurl,
					dataType: "json",
					method: 'post',
					data: {
						action: 'WooZonePNF_Envato_ajax',
						sub_action: "get_account"
					},
					// Handle the successful result
					success: function( response ) {
						if( response.status == 'valid' ){
							rel.html( response.html ); 
							preload.hide();
						}
					}
				});
				
			}
			else{
				preload.hide();
			}
			that.addClass('on');
		});
		
		if( $('.WooZonePNF-tmdb-auth-box-header').data('default') == 'ok' ){
			$('.WooZonePNF-tmdb-auth-box-header a').eq(1).click();
		}else{
			$('.WooZonePNF-tmdb-auth-box-header a').eq(0).click();
		}
		
		$('body').on('click', 'button.WooZonePNF-add-btn', function(e){
			e.preventDefault();
			add_product( $(this) );
		});
		
		$('body').on('click', '#WooZonePNF-search-on-amazon, .WooZonePNF-items-pagination button, .WooZonePNF-find-product-by-id', function(e){
			e.preventDefault();
			
			var that = $(this),
				type = 'keyword';
			
			if( that.hasClass("WooZonePNF-find-product-by-id") ){
				type = 'asin';
			}
			 
			launch_amazon_search( that, type );
		});

		// Pagination links, sortable link
		maincontainer.find('.tablenav-pages a, .manage-column.sortable a, .manage-column.sorted a').on('click', function(e) {
			e.preventDefault();
			
			// use the URL to extract our needed variables
			var query = search.substring( 1 );
			
			var data = {
				paged: __query( query, 'paged' ) || '1',
				order: __query( query, 'order' ) || 'desc',
				orderby: __query( query, 'orderby' ) || 'id'
			};
  
			update( data );
		});

		// page number input
		maincontainer.find('input[name=paged]').on('keyup', function(e) {

			// If user hit enter, we don't want to submit the form
			if ( 13 == e.which )
				e.preventDefault();

			// This time we fetch the variables in inputs
			var data = {
				paged: parseInt( maincontainer.find('input[name=paged]').val() ) || '1',
				order: maincontainer.find('input[name=order]').val() || 'desc',
				orderby: maincontainer.find('input[name=orderby]').val() || 'id',
				filter_by: maincontainer.find('input[name=filter_by]').val() || 'post',
			};
 
			update( data );
		});
		
		maincontainer.find('select[name=filter_by]').on('change', function(e) {
			var that = $(this),
				val = that.val();
			
			maincontainer.find('select[name=filter_by]').val( val ); 
		});
		
		// bulk actions - Apply
        maincontainer.find('input#doaction').on('click', function(e) {
            e.preventDefault();
            
            var that = $(this),
                form = that.parents('form').eq(0),
                _action = form.find('select#bulk-action-selector-top').val();
 
            // '_ajax_custom_list_nonce', 'ajaxid', 'order', 'orderby', '_wpnonce', '_wp_http_referer'
            var field_reset = ['_ajax_custom_list_nonce', 'ajaxid', 'order', 'orderby', '_wp_http_referer'];
            for (var i in field_reset) {
                $( 'input[name="'+field_reset[i]+'"]' ).remove();
            }
            if ( 'delete' == _action ) {
                $( 'input[name="paged"]' ).val(1);
            }
  
            form.submit();
        });
		
		$('.WooZonePNF-wp-color-picker').wpColorPicker();
		
        $('body').on('click', '.WooZonePNF-saveOptions', function(e) {
            e.preventDefault();
            saveOptions( $(this) );
        });
        
        maincontainer.find('#WooZonePNF-tmdb-auth-button').on('click', function(e) {
        	e.preventDefault();
        	
        	tmdb_auth( $(this) ); 
        });
        
        $('body').on('click', '.WooZonePNF-show-all-options', function(e) {
            e.preventDefault();
            
            var that = $(this).parents('form').eq(0);
            
            that.find(".we-complex-options").removeClass('we-complex-options');
        });

        maincontainer.find('.WooZonePNF_iw-register_plugin').on('click', '.WooZonePNF_iw-dashboard-button', function(e) {
        	e.preventDefault();

        	register_plugin( $(this) );
        });

        maincontainer.on('click', '.WooZonePNF_iw-require_register', function(e){
        	e.preventDefault();

        	$(".WooZonePNF_iw-dashboard-input[name='WooZonePNF_iw-validation-token']").focus();
        });

        maincontainer.find('.WooZonePNF-select-wrapper').on('click', '.WooZonePNF-select-item:not(.select-on)', function(e) {
        	e.preventDefault();

        	var that = $(this),
        		parent = that.parent();

        	parent.find(".select-on").removeClass('select-on');
        	parent.find("input").removeAttr("checked");

        	that.addClass('select-on');
        	that.find("input").attr('checked', true);
        });

        font_preview();

        maincontainer.find('.WooZonePNF_sales_page').on('click', 'a', function(e) {
        	e.preventDefault();

        	var that = $(this).parent().find('input'),
        		parent = that.parent(),
        		base_url = parent.find("span").text();

        	window.open( base_url + that.val(),'_blank' );
        	saveOptions( $(this) );
        	return true;
        });

        /*maincontainer.find('.WooZonePNF-timepicker').datetimepicker({
        	timeFormat: 'HH:mm:ss',
        	dateFormat: 'yy-mm-dd',
        	showSecond: true
        });*/

        maincontainer.on('click', ".WooZonePNF-export-now", function(e){
        	e.preventDefault();

        	var that = $(this),
        		label = that.parents(".WooZonePNF-form-item").eq(0);

        	loading.show();

        	var data = {
	            'action'	: 'WooZonePNF_action',
	            'sub_action': 'export_settings',
				'params'	: {
				}
	       	};

	       	var url = ajaxurl;

	       	url += '?action=' + data.action;
	       	url += '&sub_action=' + data.sub_action;
	       	url += '&';

	       	var parts = [];
			$.each(data.params, function( key, value ){
				parts.push(encodeURIComponent(key) + '=' + 
					encodeURIComponent(value));
			})
			  

			url += parts.join('&');

			console.log( url  );
			
			//download_URL( url );

			loading.hide();
        });
        

        maincontainer.on('click', ".WooZonePNF-btn-upload-delete", function(e){
        	e.preventDefault();

        	if( confirm("Are you sure you want to delete this image?") ){
	        	var that = $(this),
	        		parent = that.parents(".WooZonePNF-upload-box-wrapper").eq(0),
	        		parent_img = parent.find('.WooZonePNF-upload-image img');

	        	parent_img.remove();
	        	parent.find("input").val('');
	        }

        });

        maincontainer.on('click', ".WooZonePNF-import-now", function(e){
        	e.preventDefault();

        	var that = $(this);

			file_frame = wp.media.frames.file_frame = wp.media({
		        title: 'Insert a media',
                //library: {type: 'all'},
                multiple: false,
                button: {text: ' Load new import file '}
		    });

		    file_frame.open();

		    file_frame.on( 'select', function() {
		    	// Get media attachment details from the frame state
      			var attachment = file_frame.state().get('selection').first().toJSON();

      			if( !confirm("Are you sure you want to overwrite the campagin?") ){
	        		return true;
	        	}

      			loading.show();

				var data = {
		            'action'	: 'WooZonePNF_action',
		            'sub_action': 'import_settings',
					'params'	: {
						'upload_id': attachment.id,
						'template_id': that.data('id')
					}
		       	};
		       	
				$.post(ajaxurl, data, function (response) {
					console.log( response  );
					loading.hide();
					window.location.reload();
		        }, 'json');

      			return;
			});

			return false;
		});

        maincontainer.on('click', ".WooZonePNF-btn-upload", function(e){
        	e.preventDefault();

        	var that = $(this),
        		parent = that.parents(".WooZonePNF-upload-box-wrapper").eq(0),
        		parent_img = parent.find('.WooZonePNF-upload-image');

			file_frame = wp.media.frames.file_frame = wp.media({
		        title: 'Insert a media',
                library: {type: 'image'},
                multiple: false,
                button: {text: 'Insert new image'}
		    });

		    file_frame.open();

		    file_frame.on( 'select', function() {
		    	// Get media attachment details from the frame state
      			var attachment = file_frame.state().get('selection').first().toJSON();

      			var img = $("<img />"),
				input = parent.find("input");

				img.attr( 'src', attachment.sizes.thumbnail.url );
				input.val( attachment.id );

				parent_img.html( img );
			});

			return false;
		});
	}
	
    var misc = {
        is_chrome: function() {
            return window.chrome;
            //return navigator.userAgent.toLowerCase().indexOf('chrome') > -1;
        }
    }

	// external usage
	return {
		'triggers'                  : triggers,
        'make_tabs'                  : make_tabs
	}
})(jQuery);
