/*
Author :  AA-Team - http://themeforest.net/user/AA-Team
*/

// Initialization and events code for the app
WooZonePNF_frontend = (function ($) {
  'use strict';

  var maincontainer = null,
    response_elm = null,
    paged = 1,
    per_page = 10,
    placeholder = '';

  // init function, autoload
  (function init() {
    // load the triggers
    $(document).ready(function () {
      maincontainer = $('.WooZonePNF-amazon-products');
      var wrapper = $('.WooZonePNF-amazon-products-wrapper');

      var where = maincontainer.data('where');
      var current_case = null;
      var customselector_woo = maincontainer.data('customselectorwoo');
      var customselector_blog = maincontainer.data('customselectorblog');

      // woocommerce case
      if (wrapper.size() == 1) {
        current_case = 'woocommerce';
        maincontainer
          .detach()
          .appendTo($('.WooZonePNF-amazon-products-wrapper'));
      }

      // custom case, if is kingdom
      else if (
        customselector_woo &&
        customselector_woo != '' &&
        $(customselector_woo).size() > 0
      ) {
        // detect if current page is product search results
        //archive search search-no-results post-type-archive-product

        if ($(customselector_woo).size() > 0) {
          current_case = 'woocommerce';
          maincontainer.detach().appendTo($(customselector_woo));
          maincontainer.show();
        }
      }

      // custom case, if is kingdom
      else if (
        customselector_blog &&
        customselector_blog != '' &&
        $(customselector_blog).size() > 0
      ) {
        // detect if current page is product search results
        //archive search search-no-results post-type-archive-product

        if ($(customselector_blog).size() > 0) {
          current_case = 'woocommerce';
          maincontainer.detach().appendTo($(customselector_blog));
          maincontainer.show();
        }
      }

      // custom case, if is kingdom
      else if ($('#kingdom-main-style-css').size() > 0) {
        // detect if current page is product search results
        //archive search search-no-results post-type-archive-product

        if (
          $(
            'body.archive.search.search-no-results.post-type-archive-product'
          ).size() > 0
        ) {
          current_case = 'woocommerce';
          maincontainer.detach().appendTo($('.kd_archive_pg'));
          maincontainer.show();
        } else {
          if ($('body.search.search-no-results').size() > 0) {
            current_case = 'blog';
            maincontainer.detach().appendTo($('.main-content-box'));
            maincontainer.show();
          }
        }
      } else {
        current_case = 'blog';
        // try to write the wrapper based on get_search_form
        var valid_wrapper = null;
        $("form[role='search']").each(function () {
          var __that = $(this);
          if (!__that.parent().hasClass('widget')) {
            valid_wrapper = __that;
          }
        });

        if (valid_wrapper != null) {
          if (valid_wrapper.parents('.site-main').eq(0).size() > 0) {
            valid_wrapper = valid_wrapper.parents('.site-main').eq(0);
          }

          if (valid_wrapper.parents('.inner-content').eq(0).size() > 0) {
            valid_wrapper = valid_wrapper.parents('.inner-content').eq(0);
          }

          valid_wrapper.append(
            "<div class='WooZonePNF-amazon-products-wrapper'></div>"
          );
          valid_wrapper = valid_wrapper.find(
            '.WooZonePNF-amazon-products-wrapper'
          );
          valid_wrapper.each(function () {
            maincontainer.detach().appendTo($(this));
          });
        }
      }

      if (where != 'both') {
        if (current_case == 'blog' && where != 'blog') {
          maincontainer.remove();
          return true;
        }

        if (current_case == 'woocommerce' && where != 'woocommerce') {
          maincontainer.remove();
          return true;
        }
      }

      response_elm = maincontainer.find('.WooZonePNF-amazon-response');

      per_page = maincontainer.data('perpage');
      placeholder = maincontainer.data('placeholder');

      save_statistics({
        action: 'new_search',
        keyword: maincontainer.data('keyword'),
        url: window.location.href,
        country: maincontainer.data('country'),
        amzsite: maincontainer.data('amzsite'),
      });

      triggers();
    });
  })();

  var Pagination = {
    code: '',

    // converting initialize data
    Extend: function (data) {
      data = data || {};
      Pagination.size = data.size || 300;
      Pagination.page = data.page || 1;
      Pagination.step = data.step || 3;
    },

    // add pages by number (from [s] to [f])
    Add: function (s, f) {
      for (var i = s; i < f; i++) {
        Pagination.code += '<a>' + i + '</a>';
      }
    },

    // add last page with separator
    Last: function () {
      Pagination.code += '<i>...</i><a>' + Pagination.size + '</a>';
    },

    // add first page with separator
    First: function () {
      Pagination.code += '<a>1</a><i>...</i>';
    },

    Click: function () {
      Pagination.page = +this.innerHTML;
      Pagination.Start();
      paged = Pagination.page;

      get_products(maincontainer);
    },

    Prev: function () {
      Pagination.page--;
      if (Pagination.page < 1) {
        Pagination.page = 1;
      }
      //Pagination.Start();

      paged = Pagination.page;

      get_products(maincontainer);
    },

    Next: function () {
      Pagination.page++;
	  /*
      if (Pagination.page > Pagination.size) {
        Pagination.page = Pagination.size;
      }
	  */
      //Pagination.Start();

      paged = Pagination.page;

      get_products(maincontainer);
    },

    Bind: function () {
      var a = Pagination.e.getElementsByTagName('a');
      for (var i = 0; i < a.length; i++) {
        if (+a[i].innerHTML === Pagination.page) a[i].className = 'current';
        a[i].addEventListener('click', Pagination.Click, false);
      }
    },

    Finish: function () {
      Pagination.e.innerHTML = Pagination.code;
      Pagination.code = '';
      Pagination.Bind();
    },

    Start: function () {
      if (Pagination.size < Pagination.step * 2 + 6) {
        Pagination.Add(1, Pagination.size + 1);
      } else if (Pagination.page < Pagination.step * 2 + 1) {
        Pagination.Add(1, Pagination.step * 2 + 4);
        Pagination.Last();
      } else if (Pagination.page > Pagination.size - Pagination.step * 2) {
        Pagination.First();
        Pagination.Add(
          Pagination.size - Pagination.step * 2 - 2,
          Pagination.size + 1
        );
      } else {
        Pagination.First();
        Pagination.Add(
          Pagination.page - Pagination.step,
          Pagination.page + Pagination.step + 1
        );
        Pagination.Last();
      }
      Pagination.Finish();
    },

    Buttons: function (e) {
      var nav = e.getElementsByTagName('a');
      nav[0].addEventListener('click', Pagination.Prev, false);
      nav[1].addEventListener('click', Pagination.Next, false);
    },

    Create: function (e) {
      var html = [
        '<a class="WooZonePNF_prev_page">&#9668; ' +
          WooZonePNF_custom.translation.prev_page +
          '</a>', // previous button
        //'<span></span>',  // pagination container
        '<a class="WooZonePNF_next_page">' +
          WooZonePNF_custom.translation.next_page +
          ' &#9658;</a>', // next button
      ];

      e.innerHTML = html.join('');
      Pagination.e = e.getElementsByTagName('span')[0];
      Pagination.Buttons(e);
    },

    // init
    Init: function (e, data) {
      Pagination.Extend(data);
      Pagination.Create(e);
      //Pagination.Start();
    },
  };

  function build_rating() {
    $('.WooZonePNF-rating').starRating({
      totalStars: 5,
      starShape: 'straight',
      starSize: 18,
      strokeWidth: 10,
      readOnly: true,
      emptyColor: '#fff',
      strokeColor: '#A84410',
      starGradient: {
        start: '#FFCF4B',
        end: '#FFCF4B',
      },
      useGradient: true,
    });
  }

  function get_products(that) {
    var keyword = that.data('keyword'),
      api_url = that.data('apiurl'),
      SearchIndex = that.data('searchindex');

    api_url = api_url.replace('{Keywords}', keyword);
    api_url = api_url.replace(
      '{paged}',
      paged > 1 ? (paged - 1) * per_page : 0
    );
    api_url = api_url.replace('{items_per_page}', per_page);
    api_url = api_url.replace('{SearchIndex}', SearchIndex);

    response_elm.append('<div class="WooZonePNF-loader"></div>');

    $.ajax({
      url: api_url,
      dataType: 'jsonp',
      jsonpCallback: 'search_callback',
      error: function (jqXHR, textStatus, errorThrown) {
        response_elm.html(
          '<div class="WooZonePNF-no-results-found">' +
            WooZonePNF_custom.translation.no_results_found +
            '</div>'
        );
        //maincontainer.find('.WooZonePNF-number-results-found').hide();
        maincontainer
          .find('.WooZonePNF_prev_page')
          .css('border-right', '1px solid #d1d3d4');
        maincontainer.find('.WooZonePNF_next_page').hide();
      },
    });
  }

  function build_pagination(total_results) {
    maincontainer
      .find('.WooZonePNF-amazon-pag-response')
      .html('<div id="WooZonePNF-pagination"></div>');

    Pagination.Init(maincontainer.find('#WooZonePNF-pagination')[0], {
      size: Math.floor(total_results / per_page),
      page: paged,
      step: 1,
    });

    if (paged > 1) {
      maincontainer.find('.WooZonePNF_prev_page').show();
    } else {
      maincontainer.find('.WooZonePNF_prev_page').hide();
    }
  }

  function build_product_box(product) {
    var html = [];

    if (product.ImageUrl == '') {
      product.ImageUrl = placeholder;
    }

    html.push(
      '<div class="WooZonePNF-product" data-asin="' + product.ASIN + '">'
    );
    if (
      maincontainer.data('showprimebadge') == 'yes' &&
      product.IsPrimeEligible > 0
    ) {
      html.push('<div class="WooZonePNF-is-prime"></div>');
    }

    var buyurl = maincontainer.data('buyurl').replace('{ASIN}', product.ASIN);
    html.push(
      '<div class="WooZonePNF-image"><a href="' +
        buyurl +
        '" target="_blank" class="WooZonePNF-monitor-redirect"><img src="' +
        product.ImageUrl +
        '" /></a></div>'
    );

    //category
    if (typeof product.category != 'undefined') {
      html.push(
        '<div class="WooZonePNF-subtitle">' + product.category + '</div>'
      );
    } else {
      html.push(
        '<div class="WooZonePNF-subtitle">' + product.Subtitle + '</div>'
      );
    }

    html.push('<div class="WooZonePNF-title">' + product.Title + '</div>');
    if (product.Rating != '') {
      html.push(
        '<div class="WooZonePNF-rating" data-rating="' +
          product.Rating +
          '"></div>'
      );
      html.push(
        '<a href="#" class="WooZonePNF-rating-totals">(' +
          product.TotalReviews +
          ')</a>'
      );
    }
    html.push('<div class="WooZonePNF-price">');

    if (typeof product.ListPrice != 'undefined') {
      html.push(
        '<div class="WooZonePNF-old-price">' + product.ListPrice + '</div>'
      );
    }
    if (typeof product.Price != 'undefined') {
      html.push(
        '<div class="WooZonePNF-new-price">' + product.Price + '</div>'
      );
    }
    html.push('<p>(as of ' + maincontainer.data('amz_as_of') + ')</p>');
    html.push('</div>');
    html.push(
      '<a href="' +
        buyurl +
        '" target="_blank" class="WooZonePNF-button WooZonePNF-monitor-redirect">' +
        maincontainer.data('btntext') +
        '</a>'
    );
    html.push('</div>');

    return html.join('\n');
  }

  function search_callback(data) {
    //console.log('data', data);
    var total_results = data['NumRecords'],
      results = data['results'],
      html = [];

    if (total_results > 0 || results.length > 0) {
      //maincontainer.find('.WooZonePNF-number-results-found').show();

      /*if( maincontainer.find('.WooZonePNF-number-results-found').html() == '' ) {
				maincontainer.find('.WooZonePNF-number-results-found').html( WooZonePNF_custom.translation.nb_results.replace('{nb_results}', total_results) );
			}*/

      maincontainer.find('.WooZonePNF_next_page').show();

      $.each(results, function (key, value) {
        html.push(build_product_box(value));
      });

      response_elm.html(html.join('\n'));

      build_rating();

      if (
        maincontainer.data('showpagination') == 'yes' &&
        total_results > per_page
      ) {
        build_pagination(total_results);
      }
    }

    // debug ...
    //console.log(total_results, results);
  }

  function save_statistics(params) {
    $.post(
      WooZonePNF_custom.ajaxurl,
      {
        action: 'WooZonePNF_save_stats',
        params: params,
      },
      function (response) {}
    );
  }

  function add_new_click(that) {
    var parent = that.parents('.WooZonePNF-product').eq(0),
      asin = parent.data('asin');

    save_statistics({
      action: 'click',
      url: that.attr('href'),
      keyword: maincontainer.data('keyword'),
      country: maincontainer.data('country'),
      amzsite: maincontainer.data('amzsite'),
    });
  }

  function triggers() {
    maincontainer.each(function () {
      get_products($(this));
    });

    $('body').on('mousedown', '.WooZonePNF-monitor-redirect', function () {
      add_new_click($(this));
    });
  }

  return {
    search_callback: search_callback,
  };
})(jQuery);

function search_callback(data) {
  WooZonePNF_frontend.search_callback(data);
}
