/*
Author     :  AA-Team - http://themeforest.net/user/AA-Team
*/
// Initialization and events code for the app
WooZonePNF_auto_finder = (function ($) {
    "use strict";
    // public
    var debug_level = 0,
    	maincontainer = null,
    	loader = null,
    	trys = 0,
    	$action_status = null;
    
	// init function, autoload
	(function init() {
		// load the triggers
		$(document).ready(function(){
			maincontainer = $(".WooZonePNF_iw");
			loader = maincontainer.find(".WooZonePNF_iw-loader");
			$action_status = maincontainer.find(".WooZonePNF-action-status.WooZonePNF-message");
			
			triggers();
		});
	})();
	
	function __query( query, variable )
	{
		var vars = query.split("&");
		for ( var i = 0; i <vars.length; i++ ) {
			var pair = vars[ i ].split("=");
			if ( pair[0] == variable )
				return pair[1];
		}
		return false;
	}
	
	
	function launch_search_for_context( that )
	{
		var post_id = that.data('postid');
		loader.find('span').html("Search Contextual Product Recommendations for post id <i>" + ( post_id ) + "</i> ");
		loader.show();
		
		//$('body').scrollTo( loader.find('span') );
		scrollToElement( loader.find('span'), 100, -300 );
		
		$("#WooZonePNF-fake-container-browser").remove();
		var fake_container = $("<iframe id='WooZonePNF-fake-container-browser' src='" + ajaxurl + "?action=WooZonePNF_launch_search_for_context&strip_tags=1&post_id=" + ( post_id ) + "'></iframe>");
		
        //var _dbg = ajaxurl + "?action=WooZonePNF_launch_search_for_context&strip_tags=1&post_id=" + ( post_id );
        //console.log( _dbg ); return false;

		$('body').append( fake_container );
		fake_container.load(function(){
			var iframe_src = decodeURIComponent( $(this).contents().find("#amzn_assoc_ad_div_adunit_0").find('iframe').attr('src') ),
				asins = __query( iframe_src, 'asins' );
			
			if( asins != "" ){
				var _asin = asins.replace(/,/g, ", ");
				loader.find('span').html("Grab details for the following products " + ( _asin ) + " from Amazon API");
				
				$.ajax({
					url: ajaxurl,
					dataType: "json",
					method: 'post',
					data: {
						action		: 'WooZonePNF_launch_amz_search',
						post_id		: post_id,
						asin 		: asins,
						search_by	: 'find-products-into-content'
					},
					// Handle the successful result
					success: function( response ) {
						
						/*if( response.status == 'not-find' && trys < 2 ){
							loader.hide();
							launch_search_for_context( that );
							return;
						}*/
						
						if( response.status == 'not-found' ){
							maincontainer.append( response.html );
						}
						else if( response.status == 'result-found' ){
							maincontainer.append( response.html );
						}
						else if( response.status == 'valid' ){
							
							console.log( response ); 
							return;

							var parent = that.parents(".WooZonePNF-auto-find-row-box").eq(0);
							
							parent.find(".WooZonePNF-message").hide();
							parent.append( response.html );
							
							trys = 0;
						}
                        loader.hide();
					}
				});
			} else {
			   loader.find('span').html("No ASINs found by using Amazon API"); 
			}
		});
		setTimeout(function() {
            loader.hide();		    
		}, 5000);
	}
	
	function remove_keyword( that, pms_callback )
	{
		var parent 	= that.parents("li").eq(0),
			message = parent.parents(".WooZonePNF-auto-find-row-box").eq(0).find(".WooZonePNF-message");
		loader.find('span').html("Remove keyword: " + parent.find(".WooZonePNF-keyword-attached-phrase").text() );
	
		$.ajax({
			url: ajaxurl,
			dataType: "json",
			method: 'post',
			data: {
				action		: 'WooZonePNF_remove_keyword',
				keyword_id	: that.data("keywoardid")
			},
			// Handle the successful result
			success: function( response ) {
			    if ( response.status == 'valid' ) {
    				var ul = that.parents("ul");
    				if( ul.find("li").size() == 1 ){
    					ul.hide();
    					message.show();
    				}
    				
    				ul.width( ul.width() - 410 );
    				
    				that.parents("li").eq(0).remove();
				}
				
				var has_callback = typeof pms_callback !== 'undefined' && $.isArray(pms_callback) && pms_callback.length == 3
				    ? true : false;

                // action status message
                if ( has_callback ) {
                    response.text = [$action_status.html(), response.text].join('<br />');
                    response.text = misc.trim( response.text );
                }
                $action_status.html( response.text )
                if ( response.status == 'valid' ) {
                    $action_status.removeClass('WooZonePNF-error').addClass('WooZonePNF-success')
                } else {
                    $action_status.removeClass('WooZonePNF-success').addClass('WooZonePNF-error')
                }
                $action_status.show();
                
                // callback execution - multiple remove
                if ( has_callback ) {
  
                    pms_callback[2]++; // next index

                    // items array length == next index...
                    if ( pms_callback[1].length > pms_callback[2] ) {
  
                        pms_callback[0]( pms_callback[1][ pms_callback[2] ], pms_callback );
                    } else { // finished

                        setTimeout(function() {
                            $action_status.hide();          
                        }, 5000);
                    }
                }
                // single remove
                else {

                    setTimeout(function() {
                        $action_status.hide();          
                    }, 5000);
                }

				loader.hide();
			}
		});
	}
	
	function import_keywords( that )
	{
		var keywords = [];
		$(".WooZonePNF-products-found .WooZonePNF-product-found-item").each(function(){
			var that = $(this);
			
			that.find(".WooZonePNF-product-found-keywords input:checked").each(function(){
				var that2 = $(this);
				
				keywords.push( $.extend({
					'phrase': that2.val()
				}, that.data('item')) );
			});
		});
		
		if( keywords.length == 0 ){
			alert( "You need to select some keywords!" );
			return;
		}
		
		var post_id = $(".WooZonePNF-products-found").data('post_id');
		$.ajax({
			url: ajaxurl,
			dataType: "json",
			method: 'post',
			data: {
				action		: 'WooZonePNF_import_keywords',
				post_id 	: post_id,
				keywords	: keywords
			},
			// Handle the successful result
			success: function( response ) {
				if( response.status == 'valid' ){
					$( "#auto-find-post_id-" + post_id ).html( response.html );
					
					$(".WooZonePNF-autofind-loader").remove();
				}
				
				// action status message
                $action_status.html( response.text )
                if ( response.status == 'valid' ) {
                    $action_status.removeClass('WooZonePNF-error').addClass('WooZonePNF-success')
                } else {
                    $action_status.removeClass('WooZonePNF-success').addClass('WooZonePNF-error')
                }
                $action_status.show();
                
                setTimeout(function() {
                    $action_status.hide();          
                }, 5000);
			}
		});
	}
	
	function _update_count_keywords()
	{
		var count = $(".WooZonePNF-product-found-item").find('input:checkbox:checked').length;
		$("#WooZonePNF-count-keywords").text(count); 
	}
	
    function scrollToElement(selector, time, verticalOffset) 
    {
        time = typeof(time) != 'undefined' ? time : 1000;
        verticalOffset = typeof(verticalOffset) != 'undefined' ? verticalOffset : 0;

        var element = jQuery(selector);
        if ( element.length <= 0 ) return false;

        var offset = element.offset();
        var offsetTop = parseInt( parseInt(offset.top) + parseInt(verticalOffset) );
        $('html, body').animate({
            scrollTop: offsetTop
        }, time);
    }

	function triggers()
	{
		$('body').on('change', ".WooZonePNF-keyword-checkbox", function(e){
			var that = $(this);
			_update_count_keywords();
		});
		
		
		$('body').on('click', ".WooZonePNF-search-for-context", function(e){
			e.preventDefault();
			loader.find('span').html('');
			$(".WooZonePNF-autofind-loader").remove();
			
			launch_search_for_context( $(this) );
		});
		
		$('body').on('click', ".WooZonePNF-keyword-remove", function(e){
			e.preventDefault();

			if( confirm("Are you sure you want to remove the keyword?") ){
				remove_keyword( $(this) );
			}
		});
		
		$('body').on('click', ".remove_all a", function(e){
			e.preventDefault();

			if( confirm("Are you sure you want to remove all keywords?") ){
				
				var items = [];
				$(this).parents('tr').eq(0).find(".WooZonePNF-keyword-remove").each(function(){
					items.push( $(this) );
				});
				
				if ( items.length == 0 ) {
				    alert('No keywords to be removed!');
				    return;
				}
				
				// callback array: function, items, current index
				remove_keyword( items[0], [remove_keyword, items, 0] );
			}
		});
		
		$('body').on('click', ".WooZonePNF-import-keywords-now", function(e){
			e.preventDefault();
			
			import_keywords( $(this) );
		});
		
		$('body').on('click', "a.WooZonePNF-icon-close", function(e){
			e.preventDefault();
			$(".WooZonePNF-autofind-loader").fadeOut(550, function(){
				$(this).remove();
			});
		});
	}
	
	var misc = {
	  
        trim: function( str ) {
            return str.replace(/^(\&nbsp\;|<br\s*\/?>*)/gi, "").replace(/(\&nbsp\;|<br\s*\/?>*)$/gi, "").trim();
        }
	};
	
	// external usage
	return {
		'triggers': triggers,
		'scrollToElement'         : scrollToElement
	}
})(jQuery);
