<?php
/**
 * Amazon module return as json_encode
 * http://www.aa-team.com
 * =======================
 *
 * @author		Andrei Dinca, AA-Team
 * @version		1.0
 */


echo json_encode(array(
	// create the box elements array
	'option_name' => WooZonePNF()->alias .'_general',

	'tabs' => array(

		WooZonePNF()->alias . '_general' => array(
			'label' 	=> 'Layout Setup',
			'elements' 	=> 'show_only_on_no_products_found,where_to_display,custom_selector_woo,custom_selector_blog,admin_preview,products_per_column,template_typography,sales_page_url,items_per_page,show_pagination,show_amazon_prime_badge',
		),

        WooZonePNF()->alias . '_amazon' => array(
            'label'     => 'Amazon Settings',
            'elements'  => 'amazon_ids,amazon_categories,checkout_type,geo_targeting,headline_text,button_text',
        ),
		
		WooZonePNF()->alias . '_responsive_overrides' => array(
			'label' 	=> 'Responsive Overrides',
			'elements' 	=> 'breakpoint_column_small_desktops, products_per_column_small_desktops, breakpoint_column_tablets, products_per_column_tablets, breakpoint_column_mobiles, products_per_column_mobiles',
		),
		
		/*WooZonePNF()->alias . '_privacy_settings' => array(
			'label' 	=> 'Privacy Settings',
			'elements' 	=> 'campaign_type,password_access,roles',
		),
        
        
		WooZonePNF()->alias . '_setup_backup' => array(
			'label' 	=> 'Import/Export',
			'elements' 	=> 'import,export',
		),*/
	),

	'elements' => array(
		
		'show_only_on_no_products_found' => array(
            'type' => 'select',
            'std' => 'yes',
            'size' => 'large',
            'title' => 'Display Auto Search if no products found:',
            'desc' => 'Set this option to NO if you want the Auto Search to display products even if the search query returns posts/products. Default option is YES, which means that the Auto search will be displayed only if the search query doesn`t return any result.',
            'options' => array(
                'yes' => 'YES',
                'no' => 'NO'
            )
        ),

		'checkout_type' => array(
            'type' => 'image_radio',
            'std' => 'add_to_cart',
            'size' => 'small',
            'title' => 'Checkout Type',
            'force_width' => '100',
            'options' => array(
                'direct' => array(
                    'caption' => 'Direct checkout',
                    'img' => WooZonePNF()->assetUrl('images/redirect.png' )
                ),
                'add_to_cart' => array(
                    'caption' => 'Add to cart button',
                    'img' => WooZonePNF()->assetUrl( 'images/add_cart.png' )
                ),
            ),
            'desc' => 'Select the checkout type, direct or add to cart.'
        ),

		'amazon_ids' => array(
			'title' => '<a href="https://affiliate-program.amazon.com/" target="_blank"><img src="' . ( WooZonePNF()->assetUrl( 'images/affiliate-logo.png') ) .'" style="max-width: 90%" /></a>',
			'type' => 'amazon_ids',
            "std" => array(
                'com' => 'you-aff-id-com',
                'uk' => 'you-aff-id-uk',
                'de' => 'you-aff-id-de',
                'fr' => 'you-aff-id-fr',
                'jp' => 'you-aff-id-jp',
                'ca' => 'you-aff-id-ca',
                'cn' => 'you-aff-id-cn',
                'in' => 'you-aff-id-in',
                'it' => 'you-aff-id-it',
                'es' => 'you-aff-id-es',
                'br' => 'you-aff-id-br',
                'mx' => 'you-aff-id-mx',
            )
		),

        'amazon_categories' => array(
            'title' => 'Search Category',
            'type' => 'amazon_categories',
            "std" => array(
                'com' => 'All',
                'uk' => 'All',
                'de' => 'All',
                'fr' => 'All',
                'jp' => 'All',
                'ca' => 'All',
                'cn' => 'All',
                'in' => 'All',
                'it' => 'All',
                'es' => 'All',
                'br' => 'All',
                'mx' => 'All',
            )
        ),

        'geo_targeting' => array(
            'title' => '<span><img src="' . ( WooZonePNF()->assetUrl( 'images/icon-geo.png') ) .'" style="max-width: 90%;display:inline-block;vertical-align: middle;" /> <span style="margin-left: 10px;display:inline-block;vertical-align: middle;">Geotargeting</span></span>',
            'type' => 'geo_targeting',
            'std' => array(
                'geo_status'    => 'on',
                'service'       => 'www.geoplugin.net',
                'default_aff'   => 'com'
            )
        ),

        'headline_text' => array(
            'type' => 'text',
            'std' => 'Search results on Amazon {amazon_site_name}',
            'size' => 'small',
            'force_width' => '500',
            'title' => 'Headline Text',
            'desc' => 'Set custom text for box headline. Default: "Search results on Amazon {amazon_site_name}"'
        ),

		'button_text' => array(
            'type' => 'text',
            'std' => 'Buy now',
            'size' => 'small',
            'title' => 'Button Text',
            'desc' => 'Set custom text for buy button.'
        ),
        
        'where_to_display' => array(
            'type' => 'select',
            'std' => 'both',
            'size' => 'large',
            'title' => 'Where to display:',
            'desc' => 'Setup where to display the Auto Search',
            'options' => array(
                'woocommerce'   => 'Only on WooCommerce Search',
                'blog'          => 'Only on Default Blog Search',
                'both'          => 'Both WooCommerce Search and Blog Search'
            )
        ),
        
		'custom_selector_woo' => array(
            'type' => 'text',
            'std' => '',
            'force_width' => '500',
            'size' => 'small',
            'title' => 'WooCommerce Html Selector',
            'desc' => 'Please specify the custom selector if your theme is missing the <code>woocommerce_no_products_found()</code> action hook or if the search results are not displayed. Ex: <code>.search-no-results .products-wrapper</code>'
        ),
        
		'custom_selector_blog' => array(
            'type' => 'text',
            'std' => '',
            'force_width' => '500',
            'size' => 'small',
            'title' => 'Blog Html Selector',
            'desc' => 'Please specify the custom selector if the search results are not displayed in the blog page. Ex: <code>.search-no-results > .container</code>'
        ),

        'products_per_column' => array(
            'type' => 'html_radio',
            'std' => 'template_1',
            'size' => 'small',
            'title' => 'Products per Column',
            'force_width' => '100',
            'options' => array(
                '1' => array(
                    'caption' => '1 item / column',
                    'html' => '<div class="WooZonePNF-grid-size" data-size="1">
                    	<i></i>
                    </div>'
                ),

                '2' => array(
                    'caption' => '2 items / column',
                    'html' => '<div class="WooZonePNF-grid-size" data-size="2">
                    	<i></i>
                    	<i></i>
                    </div>'
                ),

                '3' => array(
                    'caption' => '3 items / column',
                    'html' => '<div class="WooZonePNF-grid-size" data-size="3">
                    	<i></i>
                    	<i></i>
                    	<i></i>
                    </div>'
                ),

                '4' => array(
                    'caption' => '4 items / column',
                    'html' => '<div class="WooZonePNF-grid-size" data-size="4">
                    	<i></i>
                    	<i></i>
                    	<i></i>
                    	<i></i>
                    </div>'
                ),

                '5' => array(
                    'caption' => '5 items / column',
                    'html' => '<div class="WooZonePNF-grid-size" data-size="5">
                    	<i></i>
                    	<i></i>
                    	<i></i>
                    	<i></i>
                    	<i></i>
                    </div>'
                ),

                '6' => array(
                    'caption' => '6 items / column',
                    'html' => '<div class="WooZonePNF-grid-size" data-size="6">
                    	<i></i>
                    	<i></i>
                    	<i></i>
                    	<i></i>
                    	<i></i>
                    	<i></i>
                    </div>'
                ),

            ),
            'desc' => 'Select how many items to display per column.'
        ),

        'items_per_page' => array(
            'type' => 'select',
            'std' => 8,
            'size' => 'large',
            'title' => 'Products per page:',
            'desc' => 'Select the number of products per page.',
            'options' => range( 1, 20 )
        ),

        'show_pagination' => array(
            'type' => 'select',
            'std' => 'yes',
            'size' => 'large',
            'title' => 'Show pagination:',
            'desc' => 'Set if you want to have pagination on product results',
            'options' => array(
                'yes' => 'YES',
                'no' => 'NO'
            )
        ),
        
		'show_amazon_prime_badge' => array(
            'type' => 'select',
            'std' => 'yes',
            'size' => 'large',
            'title' => 'Show Amazon Prime Badge:',
            'desc' => '',
            'options' => array(
                'no' => 'NO',
                'yes' => 'YES'
            )
        ),

        'template_typography' => array(
            'type'              => 'template_typography',
            'std'               => '',
            'title'             => 'Product Typography',
            'desc'              => '',
            'size'              => 'small',
            'options'           => array(
                'headline' => array(
                    'title' => 'Box Headline',
                    'size' => '24px',
                    'weight' => 'bold',
                    'color' => '#000',
                    'family' => 'Droid Sans',
                ),

                'product_title' => array(
                    'title' => 'Product Title',
                    'size' => '14px',
                    'weight' => 'bold',
                    'color' => '#131313',
                    'family' => 'Droid Sans',
                ),

                'product_sub_title' => array(
                    'title' => 'Product Sub Title',
                    'size' => '14px',
                    'weight' => 'bold',
                    'color' => '#131313',
                    'family' => 'Droid Sans',
                ),

                'nb_of_reviews' => array(
                    'title' => 'Number of reviews',
                    'size' => '12px',
                    'weight' => 'normal',
                    'color' => '#ff7209',
                    'family' => 'Droid Sans',
                ),

                'buy_btn' => array(
                    'title' => 'Buy button',
                    'size' => '12px',
                    'color' => '#fff',
                    'family' => 'Droid Sans',
                    'background-color' => '#ff7209'
                ),

                'regular_price' => array(
                    'title' => 'Regular price text',
                    'size' => '14px',
                    'color' => '#afafaf',
                    'family' => 'Droid Sans',
                ),

                'sale_price' => array(
                    'title' => 'Sale price text',
                    'size' => '20px',
                    'color' => '#121212',
                    'family' => 'Droid Sans',
                ),
            )
        ),

	    

	    'password_access' => array(
	        'type' => 'password_access',
	        'title' => 'Password Access',
	        'desc' => 'Generate a password or use your own password to access the products sales page',
	    ),

	    'roles' => array(
	        'type' => 'multiselect_left2right',
	        'title' => 'Roles access',
	        'options' => WooZonePNF()->get_roles(),
	        'desc' => 'Show pages only for custom roles',
	    ),

	    'import' => array(
	        'type' => 'import',
	        'title' => 'Import',
	        'std' => '',
	    ),

	    'export' => array(
	        'type' => 'export',
	        'title' => 'Export',
	        'std' => '',
	    ),
		
		'breakpoint_column_small_desktops' => array(
            'type' => 'text',
            'std' => '1280px',
            'size' => 'small',
            'title' => 'Breakpoint Small Desktops',
            'desc' => 'Breakpoint resolution on small desktops ( @media only screen and (max-width : 1280px) )'
        ),
		
		'products_per_column_small_desktops' => array(
            'type' => 'html_radio',
            'std' => 'template_1',
            'size' => 'small',
            'title' => 'Products per Column',
            'force_width' => '100',
            'options' => array(
                '1' => array(
                    'caption' => '1 item / column',
                    'html' => '<div class="WooZonePNF-grid-size" data-size="1">
                    	<i></i>
                    </div>'
                ),

                '2' => array(
                    'caption' => '2 items / column',
                    'html' => '<div class="WooZonePNF-grid-size" data-size="2">
                    	<i></i>
                    	<i></i>
                    </div>'
                ),

                '3' => array(
                    'caption' => '3 items / column',
                    'html' => '<div class="WooZonePNF-grid-size" data-size="3">
                    	<i></i>
                    	<i></i>
                    	<i></i>
                    </div>'
                ),

                '4' => array(
                    'caption' => '4 items / column',
                    'html' => '<div class="WooZonePNF-grid-size" data-size="4">
                    	<i></i>
                    	<i></i>
                    	<i></i>
                    	<i></i>
                    </div>'
                ),
            ),
            'desc' => 'Select how many items to display per column.'
        ),
		
		'breakpoint_column_tablets' => array(
            'type' => 'text',
            'std' => '1024px',
            'size' => 'small',
            'title' => 'Breakpoint Tablets',
            'desc' => 'Breakpoint resolution on small desktops ( @media only screen and (max-width : 1024px) )'
        ),
		
		'products_per_column_tablets' => array(
            'type' => 'html_radio',
            'std' => 'template_1',
            'size' => 'small',
            'title' => 'Products per Column',
            'force_width' => '100',
            'options' => array(
                '1' => array(
                    'caption' => '1 item / column',
                    'html' => '<div class="WooZonePNF-grid-size" data-size="1">
                    	<i></i>
                    </div>'
                ),

                '2' => array(
                    'caption' => '2 items / column',
                    'html' => '<div class="WooZonePNF-grid-size" data-size="2">
                    	<i></i>
                    	<i></i>
                    </div>'
                ),

                '3' => array(
                    'caption' => '3 items / column',
                    'html' => '<div class="WooZonePNF-grid-size" data-size="3">
                    	<i></i>
                    	<i></i>
                    	<i></i>
                    </div>'
                ),

                '4' => array(
                    'caption' => '4 items / column',
                    'html' => '<div class="WooZonePNF-grid-size" data-size="4">
                    	<i></i>
                    	<i></i>
                    	<i></i>
                    	<i></i>
                    </div>'
                ),
            ),
            'desc' => 'Select how many items to display per column.'
        ),
		
		'breakpoint_column_mobiles' => array(
            'type' => 'text',
            'std' => '425px',
            'size' => 'small',
            'title' => 'Breakpoint Mobiles',
            'desc' => 'Breakpoint resolution on small desktops ( @media only screen and (max-width : 425px) )'
        ),
		
		'products_per_column_mobiles' => array(
            'type' => 'html_radio',
            'std' => 'template_1',
            'size' => 'small',
            'title' => 'Products per Column',
            'force_width' => '100',
            'options' => array(
                '1' => array(
                    'caption' => '1 item / column',
                    'html' => '<div class="WooZonePNF-grid-size" data-size="1">
                    	<i></i>
                    </div>'
                ),

                '2' => array(
                    'caption' => '2 items / column',
                    'html' => '<div class="WooZonePNF-grid-size" data-size="2">
                    	<i></i>
                    	<i></i>
                    </div>'
                ),

                '3' => array(
                    'caption' => '3 items / column',
                    'html' => '<div class="WooZonePNF-grid-size" data-size="3">
                    	<i></i>
                    	<i></i>
                    	<i></i>
                    </div>'
                ),
            ),
            'desc' => 'Select how many items to display per column.'
        ),


	), // end elements
));