/*
Document   :  Insane Import
Author     :  Andrei Dinca, AA-Team http://codecanyon.net/user/AA-Team
*/

// Initialization and events code for the app
WooZonePNFProducts = (function($) {
	"use strict";

	// public
	var debug_level = 0;
	var maincontainer = null;
	var background_loading_container = null;
	var loading = null;
	var template = null;
	var autosave = null;
	var campaign = null;
	var autosave_time = 15; // in seconds
	var autosave_int = 0;

	// init function, autoload
	(function init() {
		// load the triggers
		$(document).ready(function() {
			maincontainer = $("#WooZonePNF_iw-section-content .WooZonePNF-products-wrapper-table");
			loading = $(".WooZonePNF_iw-loader");
			template = maincontainer.find("#WooZonePNF-box-tpl").html();
			background_loading_container = maincontainer.find(".WooZonePNF-insane-work-in-progress");

			campaign = $("#WooZonePNF-campaign_id").val();
			boxes_populate();
			triggers();
		});
	})();
	
	function auto_save_products( that )
	{
		autosave_int = setInterval(function(){
			if( autosave_time <= 0 ){
				// !!! de terminat aici 
				//console.log( 'do autosave'  );

				clearInterval( autosave_int );

				var __ = autosave.html();

				autosave.html(" doing autosave ...");

				setTimeout( function(){
					console.log( 'resume '  );

					autosave.html(__);

					auto_save_products();
					autosave_time = 16;	
				}, 32000 );

				return true;
			}


			autosave_time--;

			autosave.find("span").text( autosave_time );

		}, 1000);
	}

	function boxes_populate()
	{
		maincontainer.find("#WooZonePNF-default-boxes").each(function(){
			var that = $(this),
				val = $.trim(that.val());

			if( val != "" ){
				val = $.parseJSON( val );

				if( typeof(val) == 'object' ){
					$.each( val, function( key, value ){
					
						var _box = $(template).clone();

						maincontainer.find(".WooZonePNF-products-box").append( _box );

						_box.find('[name="WooZonePNF-box-name"]').val( value.name );
						_box.find('[name="WooZonePNF-box-percentage"]').val( value.percentage );

						$.each( value.products, function(key2, product){
							var _product = $('<li />'),
								box_items = _box.find(".WooZonePNF-products-box-items");
							_product.data("id", product.id );

							if( typeof(product.discount) == "undefined" ){
								product.discount = 0;
							}
							_product.append("<img src='" + ( product.url ) + "' />");
							_product.append('<a href="#" class="WooZonePNF-button WooZonePNF-small red WooZonePNF-remove-item">remove</a>');
							_product.append('<div class="WooZonePNF-discount-wrapper"><input type="text" value="' + ( product.discount ) + '" class="WooZonePNF-discount" /> <span>%</span></div>');

							box_items.find(".WooZonePNF-no-products").hide();
							box_items.append( _product );
						});
					});
				}
			}


			maincontainer.find(".WooZonePNF-products-box-items").sortable({
				containment: "parent",
				items: "> li",
				tolerance: "pointer"
			});
		});
	}

	function save_products()
	{
		loading.show();

		var boxes = [];
		maincontainer.find(".WooZonePNF-products-box > li").each(function(){
			var that = $(this);

			var params = {};

			params['name'] = that.find('[name="WooZonePNF-box-name"]').val();
			params['percentage'] = that.find('[name="WooZonePNF-box-percentage"]').val();

			var products = [];
			that.find(".WooZonePNF-products-box-items > li").each(function(){
				products.push( {
					'id' : $(this).data('id'),
					'discount' : $(this).find('input').val(),
					'url' : $(this).find('img').eq(0).attr('src')
				} );
			});
			
			params['products'] = products;

			boxes.push(params);
		});

		var data = {
            'action'	: 'WooZonePNF_products_actions',
            'sub_action': 'save-boxes',
			'params'	: {
				'campaign': campaign,
				'boxes'	: boxes
			}
       	};

       	$.post(ajaxurl, data, function (response) {
			
			if( response.status == 'valid'){
				
			}

			loading.hide();
			
        }, 'json');
	}

	function make_draggable()
	{
		maincontainer.find(".WooZonePNF-the-products-items li").draggable({ 
			helper: "clone"
		});

		maincontainer.find(".WooZonePNF-products-box-items").droppable({
			accept: maincontainer.find(".WooZonePNF-the-products-items > li"),
			hoverClass: "WooZonePNF-products-box-items-hover",
			drop: function( event, ui ) {
				var _clone  = ui.draggable.clone(),
					that 	= $(this);
				ui.draggable.remove();

				that.find("span.WooZonePNF-no-products").hide();

				that.append( _clone );

				that.sortable({
					containment: "parent",
					items: "> li",
					tolerance: "pointer"
				});
			}
		});
	}

	function load_products( that )
	{
		loading.show();

		var data = {
            'action'	: 'WooZonePNF_products_actions',
            'sub_action': 'load-products',
			'params'	: {
				'category'	: that.val()
			}
       	};

       	$.post(ajaxurl, data, function (response) {
			
			if( response.status == 'valid'){
				maincontainer.find(".WooZonePNF-the-products-items").html( response.html );
				make_draggable();
			}

			loading.hide();
			
        }, 'json');	
	}
	
	function remove_item_from_box( that )
	{
		var parent = that.parent('li'),
			_clone = parent.clone(),
			items = maincontainer.find(".WooZonePNF-the-products-items"),
			container = parent.parents('ul').eq(0);

		items.append( _clone );

		parent.remove();
		make_draggable();

		if( container.find('li').size() == 0 ){
			container.find("span.WooZonePNF-no-products").show();
		}
	}

	function add_text_box()
	{
		maincontainer.find(".WooZonePNF-products-box").append( template );
		make_draggable();
	}

	function compress_box( that )
	{
		var parent = that.parents("li").eq(0),
			headline = parent.find(".WooZonePNF-products-compress-headline"),
			box_name = parent.find("[name='WooZonePNF-box-name']").val();

		parent.addClass('WooZonePNF-products-is_compress');
		headline.find("span").eq(0).text( box_name );
		headline.find("span").eq(1).text( parent.find('.WooZonePNF-products-box-items li').size() );
	}

	function apply_discount( that )
	{
		var parent = that.parents("li").eq(0),
			products = parent.find(".WooZonePNF-products-box-items"),
			percentage = parseInt( parent.find("[name='WooZonePNF-box-percentage']").val() );

		if( !confirm("Are you sure you want to set discount for all box products?") ){
			return;
		}

		products.find("input").val(percentage);
	}

	function remove_box( that )
	{
		if( !confirm("Are you sure you want to delete all box and box content?") ){
			return;
		}
		
		that.parents("li").eq(0).remove();
	}

	function triggers()
	{
		maincontainer.on('change', ".WooZonePNF-box-select-category", function(e){
			e.preventDefault();
			
			load_products( $(this)  );
		});

		$('body').on('click', 'a.WooZonePNF-remove-item', function(e){
			e.preventDefault();
			remove_item_from_box( $(this) );
		});

		maincontainer.on('click', 'a#WooZonePNF-add-new-box', function(e){
			e.preventDefault();
			add_text_box();
		});

		maincontainer.on('click', '.WooZonePNF-products-box-compress', function(e){
			e.preventDefault();
			
			compress_box( $(this)  );
		});

		maincontainer.on('click', '.WooZonePNF-products-box-expand', function(e){
			e.preventDefault();
			
			$(this).parents("li").removeClass('WooZonePNF-products-is_compress');
		});

		maincontainer.on('click', '#WooZonePNF-save-products', function(e){
			e.preventDefault();
			
			save_products();
		});
 	
 		maincontainer.on('click', '.WooZonePNF-apply-discount', function(e){
			e.preventDefault();
			
			apply_discount( $(this) );
		});

 		maincontainer.on('click', '.WooZonePNF-remove-box', function(e){
			e.preventDefault();
			
			remove_box( $(this) );
		});
		

		
		//$("a#WooZonePNF-add-new-box").click();
		//$("a#WooZonePNF-add-new-box").click();
		//$("a#WooZonePNF-add-new-box").click();
	}

	// external usage
	return {
		"save_products": save_products
	}
})(jQuery);

