<?php
 /**
 * Amazon module
 * http://www.aa-team.com
 * ======================
 *
 * @package		WooZonePNF_
 * @author		Andrei Dinca, AA-Team
 * @version		1.0
 */
! defined( 'ABSPATH' ) and exit;

if(class_exists('WooZonePNF_products') != true) {
	class WooZonePNF_products {
		
		const WXR_VERSION = '1.0';
		
		/**
		 * parent storage
		 *
		 * @var array
		 */
		public $parent = array();
		
		private $action = '';
		private $wp_import = null;
		
		/**
		 * The constructor
		 */
		public function __construct( $parent=array() )
		{
			// load parent
			$this->parent = $parent; 

			add_action( 'wp_ajax_WooZonePNF_products_actions', array( $this, 'ajax_request' ) );
		}
		
		public function print_interface()
		{
			$html[] = '<div id="WooZonePNF_iw-section-content">';
			$html[] = 	'<div class="WooZonePNF-products-wrapper">';
			$html[] = 		'<div class="WooZonePNF-products-wrapper-table">';
			$html[] = 			'<div class="WooZonePNF-products-left">';
			$html[] = 				'<header>';
			$html[] = 					'<a href="#" target="blank" class="' . ( WooZonePNF()->alias ) . '-button yellow" id="WooZonePNF-add-new-box">Add new box</a>';
			$html[] = 					'<a href="' . ( home_url( '?' . ( WooZonePNF()->alias ) . '_page=products&campaign_id=' . WooZonePNF()->get_campaign_id() . '&key=' . WooZonePNF()->preview_key('products') ) ) . '" target="blank" class="' . ( WooZonePNF()->alias ) . '-button red" id="WooZonePNF-view-product-page">Preview products page</a>';
			$html[] = 				'</header>';
			$html[] = 				'<ul class="WooZonePNF-products-box">';
			$html[] = 					'<script type="text/template" id="WooZonePNF-box-tpl">';
			//$html[] = 					'<li class="WooZonePNF-products-is_compress">';
			$html[] = 					'<li>';
			$html[] = 						'<span class="WooZonePNF-products-compress-headline"> Box title: <span></span> &nbsp; Number of products<span></span></span>';
			$html[] = 						'<span class="WooZonePNF-products-box-drag"><i class="fa fa-bars" aria-hidden="true"></i></span>';
			$html[] = 						'<span class="WooZonePNF-products-box-compress"><i class="fa fa-compress" aria-hidden="true"></i></span>';
			$html[] = 						'<span class="WooZonePNF-products-box-expand"><i class="fa fa-expand" aria-hidden="true"></i></span>';
			$html[] = 						'<div class="WooZonePNF-products-box-setup">';
			$html[] = 							'<label>';
			$html[] = 								'<span>Box Name</span>';
			$html[] = 								'<input type="text" name="WooZonePNF-box-name" value="Untitled">';
			$html[] = 							'</label>';
			$html[] = 							'<label>';
			$html[] = 								'<span>Apply Percentage Off</span>';
			$html[] = 								'<input type="text" name="WooZonePNF-box-percentage">';
			$html[] = 								'<a href="#" target="blank" class="' . ( WooZonePNF()->alias ) . '-apply-discount ' . ( WooZonePNF()->alias ) . '-button ' . ( WooZonePNF()->alias ) . '-small yellow">Apply discount</a>';
			$html[] = 							'</label>';
			$html[] = 							'<label style="float: right; position: relative; bottom: -7px">';
			$html[] = 								'<a href="#" target="blank" class="' . ( WooZonePNF()->alias ) . '-button ' . ( WooZonePNF()->alias ) . '-remove-box ' . ( WooZonePNF()->alias ) . '-small red">Remove box</a>';
			$html[] = 							'</label>';
			$html[] = 						'</div>';
			$html[] = 						'<ul class="WooZonePNF-products-box-items">';
			$html[] = 							'<span class="WooZonePNF-no-products">drag your products here</span>';
			$html[] = 						'</ul>';
			$html[] = 					'</li>';
			$html[] = 					'</script>';

			$box_products = get_option( WooZonePNF()->alias . '_' . ( WooZonePNF()->get_campaign_id() ) . '_products', true );
			
			$html[] = 				'<textarea id="WooZonePNF-default-boxes">' . ( json_encode($box_products) ) . '</textarea>';
			$html[] = 				'</ul>';
			$html[] = 				'<div class="WooZonePNF-save-products-box">';
			$html[] = 					'<a href="#" class="' . ( WooZonePNF()->alias ) . '-button yellow" id="WooZonePNF-save-products">Save Products</a>';
			//$html[] = 					'<span class="WooZonePNF-save-products-box-autosave">Autosave in <span>15</span> seconds ...</span>';
			$html[] = 				'</div>';
			$html[] = 			'</div>';
			$html[] = 			'<div class="WooZonePNF-products-right">';

			if( WooZonePNF()->woocommerce_install() === true ){
			$html[] = 				'<div class="WooZonePNF-chose-products">';

			$args = array(
				'show_option_none' => esc_html__( 'Select category', 'WooZonePNF' ),
				'show_count'       => 1,
				'orderby'          => 'name',
				'echo'             => 0,
				'class'             => "WooZonePNF-box-select-category",
				'hierarchical'     => 1,
				'taxonomy'		   => 'product_cat',
				'tab_index'		   => 1
			);

			$total_products = count( get_posts( array('post_type' => 'product', 'post_status' => 'publish', 'fields' => 'ids', 'posts_per_page' => '-1') ) );
			$select = wp_dropdown_categories( $args );
			$select = str_replace( "<option value='-1'>Select category</option>", '<option value="-1">Select category</option><option value="-all-">View All products (' . ( $total_products ) . ')</option>', $select);

			$html[] = 				$select;
			$html[] = 				'</div>';
			$html[] = 				'<div class="WooZonePNF-the-products-items-wrapper">';
			$html[] = 					'<ul class="WooZonePNF-the-products-items">';
			$html[] = 						'';
			$html[] = 					'</ul>';
			$html[] = 				'</div>';
			}else{
				$html[] = 	'<div class="WooZonePNF-no-woocoomerce">';
				$html[] = 		'<h3>Not WooCommerce</h3>';
				$html[] = 		'<div class="WooZonePNF-table-2cols">';
				$html[] = 			'<img src="' . ( plugin_dir_url( __FILE__ ) ) . 'assets/woocommerce.png" />';
				$html[] = 			'<span>Please Install and Activate Woocommerce Plugin</span>';
				$html[] = 		'</div>';
				$html[] = 		'<a href="' . ( admin_url('plugin-install.php?s=woocommerce&tab=search&type=term') ) . '" class="' . ( WooZonePNF()->alias ) . '-button yellow">Install/Activate now</a>';
				$html[] = 	'</div>';
			}
			$html[] = 			'</div>';
			$html[] = 		'</div>';
			$html[] = 	'</div>';
			$html[] = '</div>';
			$html[] = '<input type="hidden" id="WooZonePNF-campaign_id" value="' . ( WooZonePNF()->get_campaign_id() ) . '" />';
			
			return implode( "\n", $html );
		}

		public function ajax_request()
		{
			$action = isset($_REQUEST['sub_action']) ? $_REQUEST['sub_action'] : 'none';
			
			$__ = array( 'load-products', 'save-boxes' );

			if( in_array($action, $__) ){
				$params = isset($_REQUEST['params']) ? $_REQUEST['params'] : array();

				if( $action == 'load-products' ){

					$args = array(
						'post_type' 		=> 'product',
						'posts_per_page' 	=> '-1',
    					'fields' 			=> 'ids'
					);

					if( $params['category'] != '-all-' ){
						$args['tax_query'] = array(
							array(
								'taxonomy' => 'product_cat',
								'field' => 'id',
								'terms' => $params['category']
							)
						);
					}
					$query = new WP_Query( $args );
					$html = array();
					if( $query && count($query->posts) > 0 ){

						foreach ($query->posts as $post_id) {
							$post_thumbnail_id = get_post_thumbnail_id( $post_id );
							$image_url = '';
							if( $post_thumbnail_id > 0 ){
								$image_url = wp_get_attachment_image_src( $post_thumbnail_id, 'thumbnail' );
								$image_url = $image_url[0];
							}

							$html[] = '<li data-id="' . ( $post_id ) . '">';
							$html[] = 	'<img src="' . ( $image_url ) . '" />';
							$html[] = 	'<a href="#" class="' . ( WooZonePNF()->alias ) . '-button ' . ( WooZonePNF()->alias ) . '-small red ' . ( WooZonePNF()->alias ) . '-remove-item">remove</a>';
							$html[] = 	'<div class="WooZonePNF-discount-wrapper"><input type="text" value="" class="WooZonePNF-discount" /> <span>%</span></div>';
							$html[] = '</li>';
						}

						die(json_encode(array(
							'status' => 'valid',
							'html' => implode( "\n", $html )
						))); 
					} 
				}

				if( $action == 'save-boxes' ){

					if( count($params['boxes']) > 0 ){

						$campaign = get_option( 'WooZonePNF_Plugin_Settings_' . $params['campaign'], true );
						foreach ($params['boxes'] as $box ) {
							if( isset($box['products']) && count($box['products']) > 0 ){
								foreach ($box['products'] as $product) {
									$product['discount'] = (float)$product['discount'];
									$product_price = (float)get_post_meta( $product['id'], '_regular_price', true );
									$old_sale_price = (float)get_post_meta( $product['id'], '_sale_price', true );
									
									if( $product_price > 0 && $product['discount'] > 0 ){
										$new_price = round( $product_price * ( 100 - $product['discount'] ) / 100, 2);

										// backup old value
										update_post_meta( $product['id'], '_WooZonePNF_old_price', $old_sale_price );

										update_post_meta( $product['id'], '_sale_price', $new_price );
										update_post_meta( $product['id'], '_price', $new_price );

										update_post_meta( $product['id'], '_sale_price_dates_from', strtotime($campaign['start_date']) );
										update_post_meta( $product['id'], '_sale_price_dates_to', strtotime($campaign['end_date']) );
									}

									if( 0 &&  $product['id'] == '1509' ){
										var_dump('<pre>', $product_price, $new_price,'</pre>'); 
										echo __FILE__ . ":" . __LINE__;die . PHP_EOL;   
									}
								} 
							}
						}
					}

					update_option( WooZonePNF()->alias . '_' . ( $params['campaign'] ) . '_products', $params['boxes'] );
					die(json_encode(array(
						'status' => 'valid',
					))); 
				}
			}
			echo __FILE__ . ":" . __LINE__;die . PHP_EOL;   
		}
	}
}